unit focusf;

{
Copyright (C) 2003 Philippe Martinole, Patrick Chevalley

http://www.teleauto.org/
philippe.martinole@teleauto.org

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses  math,u_modelisation2, u_class, u_constants, ExtCtrls, StdCtrls, Controls, Classes,clipbrd,
  Windows, Messages, SysUtils, Graphics, Forms, Dialogs, Videocap,vfwcap;

type
  TFocus = class(TForm)
    LYmax: TLabel;
    Label4: TLabel;
    LXmax: TLabel;
    Label5: TLabel;
    Label2: TLabel;
    Lfwhm: TLabel;
    Label3: TLabel;
    Lelong: TLabel;
    Button1: TButton;
    Label1: TLabel;
    Limaxr: TLabel;
    Image2: TImage;
    led: TEdit;
    Edit1: TEdit;
    Label6: TLabel;
    Image3: TImage;
    Label7: TLabel;
    Edit2: TEdit;
    Label8: TLabel;
    Lflux: TLabel;
    ComboBox1: TComboBox;
    Image1: TImage;
    Button2: TButton;
    Label9: TLabel;
    Label10: TLabel;
    ComboBox2: TComboBox;
    Label11: TLabel;
    ComboBox3: TComboBox;
    CheckBox1: TCheckBox;
    Label12: TLabel;
    Timer1: TTimer;
    limaxg: TLabel;
    limaxb: TLabel;
    procedure Button1Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Edit1Change(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ComboBox1Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure ComboBox3Change(Sender: TObject);
    procedure Image1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

Procedure ReceiveFocusFrame(fima : Tbitmap);

var
  Focus: TFocus;
  qcnb, infocus : boolean;
  graphl,FWHMmax,Imaxmax,WinSize,SaveCaptimeLimit,SaveMicroSecPerFrame,NfocusImage,RefInterval : integer;
  px,py,ds,image1w,image1h : smallint;
  flux,pa,ds1,ds2,lastfocus : double;
  debug : integer = 0;
  WinX : integer = -1;
  WinY : integer = -1;
  s : double = -1;
  BmInf:TBitmapInfo;   // Info of Bitmapformat
  FocusTimer : boolean = false;
  lockfocus : boolean = false;
  FrameReceived : boolean = false;
implementation

uses mainf;

{$R *.DFM}
var ima : tbitmap;

Procedure DoFocus;
var
    imgh,imgw,imaxr,imaxg,imaxb : integer;
    imax,x,y,exc,fwhm : double;
    DataInt : PTabImgInt;
    DummyDouble : PTabImgDouble;
    PSF,psfmin:TPSF;
    Sx,Sy,i,j,nn,larg,xx,yy,maxval,minval,valeur,mi,mx,Ix,Iy : smallint;
    p : PByteArray;
    ex,ey,th : double;
    ne,ex1,ey1,dc : integer;
    elp : array [1..22] of Tpoint;

begin
try
with focus do begin
nn:=strtoint(combobox2.text);
psfmin.SigmaX:=32767;
psfmin.SigmaY:=32767;
imax:=0; imaxr:=0; imaxg:=0; imaxb:=0;
inc(NfocusImage);
// ellipse
if (NfocusImage<nn)and(flux>0) then  with image1.Canvas do begin
     focus.image1.canvas.StretchDraw(rect(0,0,Image1w,Image1h),ima);
        Pen.Width:=1;
        Brush.Style:=bsClear;
        Pen.Mode:=pmCopy;
        Pen.Color:=clRed;
        th:=0;
        for ne:=1 to 22 do begin
            ex:=10*ds1*cos(th);
            ey:=10*ds2*sin(th);
            ex1:=round(ex*sin(pa) - ey*cos(pa)) + px ;
            ey1:=round(ex*cos(pa) + ey*sin(pa)) + py ;
            elp[ne]:=Point(ex1,ey1);
            th:=th+0.3;
        end;
        Polygon(elp);
        if (not CheckBox1.checked) and (WinX>0) then begin
           Pen.Width:=1;
           rectangle(round(s*(WinX-WinSize)),round(s*(WinY-WinSize)),round(s*(WinX+WinSize)),round(s*(WinY+WinSize)));
        end;
        Brush.Style:=bsSolid;
        image1.repaint;
        application.processmessages;
end;
// taile de recherche
if (not CheckBox1.checked) and (WinX>0) then begin
   Ix:=maxintvalue([1,WinX-Winsize]);
   Iy:=maxintvalue([1,WinY-Winsize]);
   Sx:=minintvalue([ima.Width-1,WinX+Winsize]);
   Sy:=minintvalue([ima.Height-1,WinY+Winsize]);
end else begin
   Ix:=1;
   Iy:=1;
   Sy:=ima.height-1;
   Sx:=ima.Width-1;
end;
// cherche le maxima
maxval:=-32767;
minval:=32767;
for i:=Iy to Sy do
    begin
    p:=ima.scanline[i-1];
    for j:=Ix to Sx do
          begin
          case ima.PixelFormat of
          pf8bit : begin
                   valeur:=p[j-1];
                   imaxr:=maxintvalue([imaxr,valeur]);
                   end;
          pf24bit: begin
                   valeur:=(P[3*(j-1)]+P[3*(j-1)+1]+P[3*(j-1)+2]) div 3;
                   imaxb:=maxintvalue([imaxb,P[3*(j-1)]]);
                   imaxg:=maxintvalue([imaxg,P[3*(j-1)+1]]);
                   imaxr:=maxintvalue([imaxr,P[3*(j-1)+2]]);
                   end;
          else     begin
                   valeur:=(P[4*(j-1)]+P[4*(j-1)+1]+P[4*(j-1)+2]) div 3;
                   imaxb:=maxintvalue([imaxb,P[4*(j-1)]]);
                   imaxg:=maxintvalue([imaxg,P[4*(j-1)+1]]);
                   imaxr:=maxintvalue([imaxr,P[4*(j-1)+2]]);
                   end;
          end;
          minval:=minintvalue([minval,valeur]);
          if valeur>maxval then
             begin
                maxval:=valeur;
                xx:=j;
                yy:=i;
             end
          end;
      end;
// ajuste sur le bord
larg:=minintvalue([WinSize,xx,ima.width-xx,yy,ima.height-yy]);
// si pas trop au bord et contraste suffisant
if (larg>=10)and((maxval-minval)>20) then begin
  WinX:=xx;
  WinY:=yy;
  sy:=2*larg;
  sx:=2*larg;      
  mx:=-32767;
  mi:=32767;
  Getmem(DataInt,4);
   Getmem(DataInt^[1],Sy*4);
   for i:=1 to sy do
      begin
      p:=ima.scanline[yy-larg+i-1];
      Getmem(DataInt^[1]^[i],Sx*2);
      for j:=1 to sx do
          begin
          case ima.PixelFormat of
          pf8bit : valeur:=p[j-1];
          pf24bit: valeur:=(P[3*(xx-larg+j-1)]+P[3*(xx-larg+j-1)+1]+P[3*(xx-larg+j-1)+2]) div 3;
          else     valeur:=(P[4*(xx-larg+j-1)]+P[4*(xx-larg+j-1)+1]+P[4*(xx-larg+j-1)+2]) div 3;
          end;
          mi:=minintvalue([mi,valeur]);
          mx:=maxintvalue([mx,valeur]);
          DataInt^[1]^[i]^[j]:=valeur;
          end;
      end;

   if (mx-mi)>20 then ModeliseEtoile(DataInt,DummyDouble,2,Sx,TGaussEllipse,lowPrecision,LowSelect,0,PSF)
                 else begin
                    psf.flux:=maxval;
                    psf.x:=xx;
                    psf.y:=yy;
                    psf.sigmax:=10;
                    psf.sigmay:=10;
                 end;

   if (DataInt<>nil) then
      begin
      for i:=1 to Sy do Freemem(DataInt^[1]^[i],Sx*2);
      Freemem(DataInt^[1],4*Sy);
      Freemem(DataInt,4);
      end;
end else begin
   psf.flux:=maxval;
   psf.x:=xx;
   psf.y:=yy;
   psf.sigmax:=99;
   psf.sigmay:=99;
end;
if psf.SigmaX<psfmin.SigmaX then begin
                            psfmin:=psf;
                            imax:=maxval;
                            end;
// fin de la sequence
if NFocusImage = nn then begin
NfocusImage:=0;
flux:=PSFmin.Flux;
x:=xx-larg+psfmin.X;
y:=yy-larg+psfmin.Y;
WinX:=round(x);
if WinX<1 then WinX:=1;
if WinX>ima.width then WinX:=ima.width;
WinY:=round(y);
if WinY<1 then WinY:=1;
if WinY>ima.height then WinY:=ima.height;
if psfmin.sigmay>0 then exc:=psfmin.sigmax/psfmin.sigmay else exc:=0;
 fwhm:=sqrt(psfmin.sigmax*psfmin.sigmax+psfmin.sigmay*psfmin.sigmay);
 Lxmax.caption:=floattostrf(x,fffixed,7,1);
 Lymax.caption:=floattostrf(y,fffixed,7,1);
 Lfwhm.caption:=floattostrf(fwhm,fffixed,7,2);
 Lelong.caption:=floattostrf(exc,fffixed,7,2);
 LImaxr.caption:='R:'+floattostrf(imaxr,fffixed,3,0);
 LImaxg.caption:='G:'+floattostrf(imaxg,fffixed,3,0);
 LImaxb.caption:='B:'+floattostrf(imaxb,fffixed,3,0);
 Lflux.caption:=floattostrf(flux,fffixed,7,0);
 if flux>0 then Lflux.color:=clBtnFace else Lflux.color:=clRed;
 ImgH:=Ima.Height;
 ImgW:=Ima.Width;
 s:=ImgW/ImgH;
 image1w:=focus.ClientWidth-image1.left;
 image1h:=round(Image1W/s);
 image1.Picture.bitmap.Width:=image1w;
 image1.Picture.bitmap.Height:=image1h;
 s:=Image1h/ImgH;
 px:=round(s*(x-0.5));
 py:=round(s*(y-0.5));
 ds:=round(s*fwhm/2);
 if ds<2 then ds:=2;
 ds1:=psfmin.sigmax;
 ds2:=psfmin.sigmay;
 ds1:=(s*ds1/2);
 ds2:=(s*ds2/2);
 pa:=pi/2-psfmin.Angle;
 with image1.Canvas do begin
     focus.image1.Canvas.StretchDraw(rect(0,0,Image1w,Image1h),ima);
     if (not CheckBox1.checked) and (WinX>0) then begin
        Brush.Style:=bsClear;
        Pen.Width:=1;
        rectangle(round(s*(WinX-WinSize)),round(s*(WinY-WinSize)),round(s*(WinX+WinSize)),round(s*(WinY+WinSize)));
     end;
     if flux>0 then begin
        Pen.Width:=1;
        Brush.Style:=bsClear;
        Pen.Mode:=pmCopy;
        Pen.Color:=clRed;
        th:=0;
        for ne:=1 to 22 do begin
            ex:=10*ds1*cos(th);
            ey:=10*ds2*sin(th);
            ex1:=round(ex*sin(pa) - ey*cos(pa)) + px ;
            ey1:=round(ex*cos(pa) + ey*sin(pa)) + py ;
            elp[ne]:=Point(ex1,ey1);
            th:=th+0.3;
        end;
        Polygon(elp);
        Brush.Style:=bsSolid;
     end;
 end;
if flux<=0 then begin

end else begin

 with image2.Canvas do begin
   inc(graphl);
   if graphl>=image2.width then graphl:=0;
   Pen.Color:=clNavy;
   moveto(graphl,0);
   lineto(graphl,image2.height);
   Pen.Color:=clRed;
   moveto(graphl,image2.height);
   lineto(graphl,image2.height-round(fwhm*100/fwhmmax));
   Pen.Color:=clGray;
   moveto(graphl+1,0);
   lineto(graphl+1,image2.height);
 end;
 with image3.Canvas do begin
   Pen.Color:=clNavy;
   moveto(graphl,0);
   lineto(graphl,image3.height);
   Pen.Color:=clLime;
   moveto(graphl,image3.height);
   lineto(graphl,image3.height-round(imax*100/Imaxmax));
   Pen.Color:=clGray;
   moveto(graphl+1,0);
   lineto(graphl+1,image3.height);
 end;
end;
end;
end; // with focus
except
end;
end;

Procedure ReceiveFocusFrame(fima : Tbitmap);
begin
if lockfocus then exit;
if now<(lastfocus+refinterval/(24*3600*1000)) then exit;
lockfocus:=true;
lastfocus:=now;
try
ima.Assign(fima);
//DoFocus;
FrameReceived:=true;
except
FrameReceived:=false;
lockfocus:=false;
end;
end;

Procedure StartFocus;
begin
if LPstatus=0 then begin
  SaveCaptimeLimit:=main.VideoCap1.captimeLimit;
  SaveMicroSecPerFrame:=main.VideoCap1.MicroSecPerFrame;
  main.VideoCap1.captimeLimit:=0;
  main.VideoCap1.MicroSecPerFrame:=RefInterval*1000;
  main.VideoCap1.CapToFile:=false;
  main.videocap1.Yield:=true;
  main.videocap1.abortkey:=0;
  main.VideoCap1.StartCapture;
end;
NfocusImage:=0;
bmInf:= main.VideoCap1.BitmapInfo;
infocus:=true;
focus.led.color:=clLime;
focus.combobox1.Enabled:=false;
focus.combobox2.Enabled:=false;
lockfocus:=false;
focus.timer1.Interval:=refinterval;
focus.timer1.enabled:=true;
//application.processmessages;
end;

Procedure StopFocus;
begin
infocus:=false;
focus.timer1.enabled:=false;
if LPstatus=0 then begin
  main.VideoCap1.StopCapture;
  main.VideoCap1.captimeLimit:=SaveCaptimeLimit;
  main.VideoCap1.MicroSecPerFrame:=SaveMicroSecPerFrame;
  main.VideoCap1.Yield:=true;
  main.VideoCap1.CapToFile:=true;
end;
focus.combobox1.Enabled:=true;
focus.combobox2.Enabled:=true;
focus.led.color:=clRed;
end;

procedure TFocus.Button1Click(Sender: TObject);
begin
if led.color=clRed then StartFocus
                   else StopFocus;
application.processmessages;
end;


procedure TFocus.FormShow(Sender: TObject);
var i,code: integer;
begin
val(combobox1.text,i,code);
if code=0 then RefInterval:=i;
lastfocus:=0;
Winsize:=strtoint(combobox3.text) div 2;
InFocus:=false;
image2.Canvas.Brush.color:=clNavy;
image2.Canvas.Pen.color:=clRed;
image2.Canvas.FillRect(rect(0,0,image2.width,image2.height));
image3.Canvas.Brush.color:=clNavy;
image3.Canvas.Pen.color:=clRed;
image3.Canvas.FillRect(rect(0,0,image3.width,image3.height));
graphl:=0;
edit1.text:=inttostr(fwhmmax);
edit2.text:=inttostr(imaxmax);
StartFocus;
end;

procedure TFocus.FormClose(Sender: TObject; var Action: TCloseAction);
begin
StopFocus;
main.WindowState:=wsNormal;
end;

procedure TFocus.Edit1Change(Sender: TObject);
var i,code: integer;
begin
val(edit1.text,i,code);
if code=0 then fwhmmax:=i;
if fwhmmax<2 then begin
             fwhmmax:=2;
             edit1.text:='2';
             end;
end;

procedure TFocus.Edit2Change(Sender: TObject);
var i,code: integer;
begin
val(edit2.text,i,code);
if code=0 then imaxmax:=i;
if imaxmax=0 then inc(imaxmax);
end;

procedure TFocus.ComboBox1Change(Sender: TObject);
var i,code: integer;
begin
val(combobox1.text,i,code);
if code=0 then RefInterval:=i;
end;

procedure TFocus.Button2Click(Sender: TObject);
begin
close;
end;

procedure TFocus.ComboBox3Change(Sender: TObject);
begin
winsize:=strtoint(combobox3.text) div 2;
end;

procedure TFocus.Image1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
if (X-winsize>0)and(X+winsize<image1.Width)and(Y-winsize>0)and(Y+winsize<image1.Height) then begin
   WinX:=round(X/s);
   WinY:=round(Y/s);
end;
end;

procedure TFocus.Timer1Timer(Sender: TObject);
begin
if FrameReceived then begin
  FrameReceived:=false;
  Dofocus;
  lockfocus:=false;
end;
end;

procedure TFocus.FormCreate(Sender: TObject);
begin
ima:=Tbitmap.create;
end;

procedure TFocus.FormDestroy(Sender: TObject);
begin
ima.free;
end;

end.
