unit u_porttalk2;

interface

uses Windows;

const
  IOCTL_IOPM_RESTRICT_ALL_ACCESS   :DWord = 2621449216;
  IOCTL_IOPM_ALLOW_EXCUSIVE_ACCESS :DWord = 2621449220;
  IOCTL_ENABLE_IOPM_ON_PROCESSID   :DWord = 2621449228;
  IOCTL_READ_PORT_UCHAR            :DWord = 2621449232;
  IOCTL_WRITE_PORT_UCHAR           :DWord = 2621449236;

procedure StartPortTalk;
function StartPortTalkDriver:Boolean;
procedure InstallPortTalkDriver;
function OpenPortTalk:Byte;
procedure ClosePortTalk;
procedure PortTalkWrite(Contenu:Byte;Adresse:Word);
function PortTalkRead(Adresse:Word):Byte;
procedure GetOS(var osver:string; var ostype:integer);

implementation

uses WinSvc, {u_file_io,} SysUtils, Dialogs;

var
  PortTalk_Handle:THandle;        // Handle for PortTalk Driver

procedure writespy(txt:string);
begin
end;


procedure GetOS(var osver:string; var ostype:integer);
var
  OS :TOSVersionInfo;
begin
  ZeroMemory(@OS,SizeOf(OS));
  OS.dwOSVersionInfoSize:=SizeOf(OS);
  GetVersionEx(OS);
  osver:='Unknown';
  ostype:=1;
  if OS.dwPlatformId=VER_PLATFORM_WIN32_NT then begin
    case OS.dwMajorVersion of
      3: osver:='Win32 NT3';
      4: osver:='Win32 NT4';
      5: osver:='Win32 2K';
    end;
    if (OS.dwMajorVersion=5) and (OS.dwMinorVersion=1) then
      osver:='Win32 XP';
  end else begin
    if (OS.dwMajorVersion=4) and (OS.dwMinorVersion=0) then begin
      osver:='Win32 95';
      ostype:=0;
      if (Trim(OS.szCSDVersion)='B') then
        osver:='Win32 95OSR2';
    end else
      if (OS.dwMajorVersion=4) and (OS.dwMinorVersion=10) then begin
        osver:='Win32 98';
        ostype:=0;
        if (Trim(OS.szCSDVersion)='A') then
          osver:='Win32 98SE';
      end else
        if (OS.dwMajorVersion=4) and (OS.dwMinorVersion=90) then begin
          osver:='Win32 ME';
          ostype:=0;
        end;
end;
end;

// Codes PortTalk
//#define PORTTALK_TYPE 40000 /* 32768-65535 are reserved for customers */

// The IOCTL function codes from 0x800 to 0xFFF are for customer use.

//#define IOCTL_IOPM_RESTRICT_ALL_ACCESS \
//    CTL_CODE(PORTTALK_TYPE, 0x900, METHOD_BUFFERED, FILE_ANY_ACCESS)

//#define IOCTL_IOPM_ALLOW_EXCUSIVE_ACCESS \
//    CTL_CODE(PORTTALK_TYPE, 0x901, METHOD_BUFFERED, FILE_ANY_ACCESS)

//#define IOCTL_SET_IOPM \
//    CTL_CODE(PORTTALK_TYPE, 0x902, METHOD_BUFFERED, FILE_ANY_ACCESS)

//#define IOCTL_ENABLE_IOPM_ON_PROCESSID \
//    CTL_CODE(PORTTALK_TYPE, 0x903, METHOD_BUFFERED, FILE_ANY_ACCESS)

//#define IOCTL_READ_PORT_UCHAR \
//    CTL_CODE(PORTTALK_TYPE, 0x904, METHOD_BUFFERED, FILE_ANY_ACCESS)

//#define IOCTL_WRITE_PORT_UCHAR \
//    CTL_CODE(PORTTALK_TYPE, 0x905, METHOD_BUFFERED, FILE_ANY_ACCESS)

// Demarrage de PortTalk a appeller au debut du programme
// PortTalk.sys doit deja etre dans /Windows/System32/Drivers
procedure StartPortTalk;
var
PortTalk_Handle:THandle;   // Handle for PortTalk Driver
Error:Boolean;             // Error Handling for DeviceIoControl()
BytesReturned:DWORD;       // Bytes Returned for DeviceIoControl() */
//PORTTALK_TYPE,IOCTL_IOPM_RESTRICT_ALL_ACCESS,FILE_ANY_ACCESS,METHOD_BUFFERED:DWord;
//IOCTL_IOPM_ALLOW_EXCUSIVE_ACCESS,IOCTL_ENABLE_IOPM_ON_PROCESSID:DWord;
//Name:LPCTSTR;
PortTalkInstalled:Boolean;
ProcessID:DWord;
begin
// Open PortTalk Driver. If we cannot open it, try installing and starting it
PortTalkInstalled:=False;
PortTalk_Handle:=CreateFile('\\.\PortTalk',GENERIC_READ,0,nil,OPEN_EXISTING, //nolang
   FILE_ATTRIBUTE_NORMAL,0);
if (PortTalk_Handle=INVALID_HANDLE_VALUE) then
   begin
   // Start or Install PortTalk Driver
   StartPortTalkDriver;
   // Then try to open once more, before failing
   PortTalk_Handle:=CreateFile('\\.\PortTalk',GENERIC_READ,0,nil,OPEN_EXISTING, //nolang
      FILE_ATTRIBUTE_NORMAL,0);

   if PortTalk_Handle=INVALID_HANDLE_VALUE then
      WriteSpy('PortTalk: Couldn''t access PortTalk Driver, Please ensure driver is loaded') //nolang
   else PortTalkInstalled:=True;
   end
else PortTalkInstalled:=True;

if PortTalkInstalled then
   begin
   // Once we have successfully opened a handle to the PortTalk Driver, we must fill the
   // driver's IOPM with 0xFF to restrict access to all ports
//   PORTTALK_TYPE:=40000;
//   FILE_ANY_ACCESS:=0;
//   METHOD_BUFFERED:=0;

//   IOCTL_IOPM_RESTRICT_ALL_ACCESS:=(PORTTALK_TYPE shl 16) or (FILE_ANY_ACCESS shl 14)
//      or ($900 shl 2) or METHOD_BUFFERED;

   Error:=DeviceIoControl(PortTalk_Handle,IOCTL_IOPM_RESTRICT_ALL_ACCESS,nil,0,nil,0,BytesReturned,nil);
   if not error then WriteSpy(Format('PortTalk: error %d occured in IOCTL_IOPM_RESTRICT_ALL_ACCESS', [GetLastError])); //nolang

//   IOCTL_IOPM_ALLOW_EXCUSIVE_ACCESS:=(PORTTALK_TYPE shl 16) or (FILE_ANY_ACCESS shl 14)
//      or ($901 shl 2) or METHOD_BUFFERED;
   WriteSpy('Granting exclusive access to all I/O Ports');  //nolang
   Error:=DeviceIoControl(PortTalk_Handle,IOCTL_IOPM_ALLOW_EXCUSIVE_ACCESS,nil,0,nil,0,BytesReturned,nil);

   ProcessID:=GetCurrentProcessId;
   WriteSpy(Format('ProcessID of %d',[ProcessID])); //nolang

//   IOCTL_ENABLE_IOPM_ON_PROCESSID:=(PORTTALK_TYPE shl 16) or (FILE_ANY_ACCESS shl 14)
//      or ($903 shl 2) or METHOD_BUFFERED;
   // Oula ! @GetCurrentProcessId donne un pointeur sur la fonction pas sur le resutat non ?
   // Ca peut etre ca qui deconne ! A tester
   Error:=DeviceIoControl(PortTalk_Handle,IOCTL_ENABLE_IOPM_ON_PROCESSID,
      @ProcessId,4,nil,0,BytesReturned,nil);

   if not Error then
      WriteSpy(Format('Error Occured talking to Device Driver %d',[GetLastError])) //nolang
   else
      WriteSpy(Format('PortTalk Device Driver has set IOPM for ProcessID %d',[ProcessId])); //nolang

   CloseHandle(PortTalk_Handle);

   OpenPortTalk;
   end;
end;

function StartPortTalkDriver:Boolean;
var
   SchSCManager:SC_HANDLE;
   schService:SC_HANDLE;
   lpServiceArgVectors:PChar;
   ret:Boolean;
   err:DWORD;
begin
   // Open Handle to Service Control Manager
   SchSCManager:=OpenSCManager(nil,                        // machine (NULL == local)
                               nil,                        // database (NULL == default)
                               SC_MANAGER_ALL_ACCESS);     // access required

    if SchSCManager=SC_Handle(nil) then
      if GetLastError=ERROR_ACCESS_DENIED then
         begin
         // We do not have enough rights to open the SCM, therefore we must
         // be a poor user with only user rights. */
         WriteSpy('PortTalk: You do not have rights to access the Service Control Manager and'); //nolang
         WriteSpy('PortTalk: the PortTalk driver is not installed or started. Please ask');//nolang
         WriteSpy('PortTalk: your administrator to install the driver on your behalf');//nolang
         Result:=False;
         end;

    schService:=SC_HANDLE(nil);
    while schService=SC_HANDLE(nil) do
//    while schService=nil do
       begin
       // Open a Handle to the PortTalk Service Database
       schService:=OpenService(SchSCManager,         // handle to service control manager database
                               'PortTalk',           // pointer to name of service to start //nolang
                               SERVICE_ALL_ACCESS);  // type of access to service

         if schService=SC_Handle(nil) then
            case GetLastError of
                ERROR_ACCESS_DENIED:begin
                                    WriteSpy('PortTalk: You do not have rights to the PortTalk service database'); //nolang
                                    Result:=False;
                                    end;
                ERROR_INVALID_NAME:begin
                                   WriteSpy('PortTalk: The specified service name is invalid'); //nolang
                                   result:=False;
                                   end;
                ERROR_SERVICE_DOES_NOT_EXIST:begin
//                                             ShowMessage('The PortTalk driver does not exist. Installing driver'+#13+
//                                                'This can take up to 30 seconds on some machines'); //nolang
                                             WriteSpy('PortTalk: The PortTalk driver does not exist. Installing driver'); //nolang
                                             WriteSpy('PortTalk: This can take up to 30 seconds on some machines'); //nolang
                                             InstallPortTalkDriver;

                                             schService:=OpenService(SchSCManager,         // handle to service control manager database
                                                'PortTalk',           // pointer to name of service to start //nolang
                                                SERVICE_ALL_ACCESS);  // type of access to service

                                             if schService=SC_Handle(nil) then
                                                begin
                                                WriteSpy('PortTalk: Can''t install driver'); //nolang
                                                Exit;
                                                end;
                                             end;
               end;
       end;

    // Start the PortTalk Driver. Errors will occur here if PortTalk.SYS file doesn't exist

//function StartService(hService: SC_HANDLE; dwNumServiceArgs: DWORD;
//  var lpServiceArgVectors: PChar): BOOL; stdcall;

    lpServiceArgVectors:=nil;
    ret:=StartService(schService,             // service identifier
                      0,                      // number of arguments
                      lpServiceArgVectors);   // pointer to arguments

    if ret then WriteSpy('PortTalk: The PortTalk driver has been successfully started') //nolang
    else
       begin
        err:=GetLastError;
        if err=ERROR_SERVICE_ALREADY_RUNNING then
           WriteSpy('PortTalk: The PortTalk driver is already running') //nolang
        else
           begin
           WriteSpy('PortTalk: Unknown error while starting PortTalk driver service'); //nolang
           WriteSpy('PortTalk: Does PortTalk.SYS exist in your \System32\Drivers Directory ?'); //nolang
           Result:=False;
           end;
       end;

    // Close handle to Service Control Manager
    CloseServiceHandle(schService);
    Result:=True;
end;

procedure InstallPortTalkDriver;
var
   schSCManager:SC_HANDLE;
   schService:SC_HANDLE;
   err:DWORD;
   DriverFileName:PChar;
//   CHAR       DriverFileName[80];

    // Get Current Directory. Assumes PortTalk.SYS driver is in this directory.
    // Doesn't detect if file exists, nor if file is on removable media - if this
    // is the case then when windows next boots, the driver will fail to load and
    // a error entry is made in the event viewer to reflect this

    // Get System Directory. This should be something like c:\windows\system32 or
    // c:\winnt\system32 with a Maximum Character lenght of 20. As we have a
    // buffer of 80 bytes and a string of 24 bytes to append, we can go for a max
    // of 55 bytes */
begin
// Marche pas
// Je laisse l'utilisateur copier le driver
{    err:=GetSystemDirectory(DriverFileName,MAX_PATH);
    if err=0 then
       begin
       WriteSpy('PortTalk: Failed to get System Directory'); //nolang
       WriteSpy('PortTalk: Please manually copy driver to your system32/driver directory '); //nolang
       end;
    if err>55 then
       begin
       WriteSpy('PortTalk: Failed to get System Directory. Is System Directory Path > 55 Characters ?'); //nolang
       WriteSpy('PortTalk: Please manually copy driver to your system32/driver directory'); //nolang
       end;

    // Append our Driver Name
    lstrcat(DriverFileName,'\Drivers\PortTalk.sys'); //nolang
    WriteSpy(Format('PortTalk: Copying driver to %s',[DriverFileName])); //nolang

    // Copy Driver to System32/drivers directory. This fails if the file doesn't exist.

    if not CopyFile('PortTalk.sys',DriverFileName,False) then //nolang
       begin
       WriteSpy(Format('PortTalk: Failed to copy driver to %s',[DriverFileName])); //nolang
       WriteSpy('PortTalk: Please manually copy driver to your system32/driver directory'); //nolang
       end;}

    // Open Handle to Service Control Manager
    SchSCManager:=OpenSCManager(nil,                    // machine (NULL == local)
                                nil,                    // database (NULL == default)
                                SC_MANAGER_ALL_ACCESS); // access required

    // Create Service/Driver - This adds the appropriate registry keys in
    // HKEY_LOCAL_MACHINE\SYSTEM\CurrentControlSet\Services - It doesn't
    // care if the driver exists, or if the path is correct.

    schService:=CreateService(SchSCManager,                      // SCManager database
                              'PortTalk',                        // name of service //nolang
                              'PortTalk',                        // name to display //nolang
                              SERVICE_ALL_ACCESS,                // desired access
                              SERVICE_KERNEL_DRIVER,             // service type
                              SERVICE_DEMAND_START,              // start type
                              SERVICE_ERROR_NORMAL,              // error control type
                              'System32\Drivers\PortTalk.sys', // service's binary //nolang
                              nil,                               // no load ordering group
                              nil,                               // no tag identifier
                              nil,                               // no dependencies
                              nil,                               // LocalSystem account
                              nil                                // no password
                              );

    if schService=SC_Handle(nil) then
       begin
       err:=GetLastError;
       if err=ERROR_SERVICE_EXISTS then
          WriteSpy('PortTalk: Driver already exists. No action taken') //nolang
       else WriteSpy('PortTalk: Unknown error while creating Service'); //nolang
       end
    else WriteSpy('PortTalk: Driver successfully installed'); //nolang

    // Close Handle to Service Control Manager
    CloseServiceHandle (schService);
end;

function OpenPortTalk:Byte;
var
   Name,msg:PChar;
   Err:DWord;
begin
   Result:=0;

   // Open PortTalk Driver. If we cannot open it, try installing and starting it
//HANDLE CreateFile(
//    LPCTSTR lpFileName,	// pointer to name of the file
//    DWORD dwDesiredAccess,	// access (read-write) mode
//    DWORD dwShareMode,	// share mode
//    LPSECURITY_ATTRIBUTES lpSecurityAttributes,	// pointer to security attributes
//    DWORD dwCreationDistribution,	// how to create
//    DWORD dwFlagsAndAttributes,	// file attributes
//    HANDLE hTemplateFile 	// handle to file with attributes to copy

// PortTalk_Handle:=CreateFile('\\.\PortTalk',GENERIC_READ,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,THandle(nil)); //nolang
   PortTalk_Handle:=CreateFile('\\.\PortTalk',GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0); //nolang
   if PortTalk_Handle=INVALID_HANDLE_VALUE then
      begin
      // Start or Install PortTalk Driver
      StartPortTalkDriver;
      // Then try to open once more, before failing
//      PortTalk_Handle:=CreateFile('\\.\PortTalk',GENERIC_READ,0,nil,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,THandle(nil)); //nolang
      PortTalk_Handle:=CreateFile('\\.\PortTalk',GENERIC_READ,0,0,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,0); //nolang
      if PortTalk_Handle=INVALID_HANDLE_VALUE then
         begin
         WriteSpy('PortTalk: Couldn''t access PortTalk Driver, Please ensure driver is loaded'); //nolang
         Result:=1;
         end;
      end;
end;

// Fermeture de PortTalk a appeller a la fin du programme
procedure ClosePortTalk;
begin
   try
   CloseHandle(PortTalk_Handle);
   except
   end;
end;

// Ecriture du le port //
procedure PortTalkWrite(Contenu:Byte;Adresse:Word);
var
//   METHOD_BUFFERED,FILE_ANY_ACCESS,PORTTALK_TYPE,IOCTL_WRITE_PORT_UCHAR:DWORD;
   Error:LongBool;
   BytesReturned:DWORD;
   Buffer:array[0..2] of Byte;
begin
   Buffer[0]:=Lo(Adresse);
   Buffer[1]:=Hi(Adresse);
//   Buffer[0]:=Adresse;
   Buffer[2]:=Contenu;

//   PORTTALK_TYPE:=40000;
//   FILE_ANY_ACCESS:=0;
//   METHOD_BUFFERED:=0;
//   IOCTL_WRITE_PORT_UCHAR:=(PORTTALK_TYPE shl 16) or (FILE_ANY_ACCESS shl 14) or ($905 shl 2) or METHOD_BUFFERED;

//    unsigned char Buffer[3];
//    unsigned short * pBuffer;
//    pBuffer = (unsigned short *)&Buffer[0];
//    *pBuffer = PortAddress;
//    Buffer[2] = byte;

//    error = DeviceIoControl(PortTalk_Handle,
//                            IOCTL_WRITE_PORT_UCHAR,
//                            &Buffer,
//                            3,
//                            NULL,
//                            0,
//                            &BytesReturned,
//                            NULL);

//function DeviceIoControl(hDevice: THandle; dwIoControlCode: DWORD; lpInBuffer: Pointer;
//  nInBufferSize: DWORD; lpOutBuffer: Pointer; nOutBufferSize: DWORD;
//  var lpBytesReturned: DWORD; lpOverlapped: POverlapped): BOOL; stdcall;

   Error:=DeviceIoControl(PortTalk_Handle,IOCTL_WRITE_PORT_UCHAR,@Buffer,3,nil,0,BytesReturned,nil);

   if not Error then WriteSpy(Format('Error occured during write while talking to PortTalk driver %d',[GetLastError])); //nolang
end;

// Lecture du le port //
function PortTalkRead(Adresse:Word):Byte;
var
//   METHOD_BUFFERED,FILE_ANY_ACCESS,PORTTALK_TYPE,IOCTL_READ_PORT_UCHAR:DWORD;
   Error:LongBool;
   BytesReturned:DWORD;
   Buffer:array[0..1] of Byte;
begin
   Buffer[0]:=Lo(Adresse);
   Buffer[1]:=Hi(Adresse);

//   PORTTALK_TYPE:=40000;
//   FILE_ANY_ACCESS:=0;
//   METHOD_BUFFERED:=0;

//   IOCTL_READ_PORT_UCHAR:=(PORTTALK_TYPE shl 16) or (FILE_ANY_ACCESS shl 14) or ($904 shl 2) or METHOD_BUFFERED;

//function DeviceIoControl(hDevice: THandle; dwIoControlCode: DWORD; lpInBuffer: Pointer;
//  nInBufferSize: DWORD; lpOutBuffer: Pointer; nOutBufferSize: DWORD;
//  var lpBytesReturned: DWORD; lpOverlapped: POverlapped): BOOL; stdcall;

   Error:=DeviceIoControl(PortTalk_Handle,IOCTL_READ_PORT_UCHAR,@Buffer,2,@Buffer,1,BytesReturned,nil);
   if not Error then WriteSpy(Format('Error occured during read while talking to PortTalk driver %d',[GetLastError])); //nolang
   Result:=Buffer[0];
end;

end.
